SystemOrganization addCategory: #'DAO-TP-Changes'!

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:19'!
cerrarUnidadDeTrabajo
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:40'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajo new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:21'!
registrarCambio: unCambio 
	^self unidadActiva registrarCambio: unCambio.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadActiva
	^unidadDeTrabajoActiva.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:50'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:55'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:54'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:55'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:49'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ Error signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 19:35'!
todosLosCambios
	^cambios.! !

TestCase subclass: #ChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:14'!
test001UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajo new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:04'!
test002UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajo new.
	unaUnidadDeTrabajo registrarCambio: self unCambio.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:04'!
test003RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajo new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self unCambio ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajo noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:02'!
test004UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	unSistemaDeCambios := SistemaDeCambios new.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:04'!
test005ElSistemaRegistraLosCambiosEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios registrarCambio: self unCambio.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 
	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:09'!
test006
	
	| unSistemaDeCambios unaUnidadDeTrabajo |
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios cerrarUnidadDeTrabajo.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 
	self assert: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 21:03'!
unCambio
	^1.! !
